<script lang="ts">
import Vue from 'vue';
import { debounce } from 'lodash';
import { capitalizeFirst } from '~/common/util';

export default Vue.extend({
  name: 'FeaturesMenu',
  props: {
    tabs: {
      type: Array,
      required: true,
      default: () => [],
    },
    defaultTab: {
      type: String,
      required: true,
    },
    dropdownLabel: {
      type: String,
      required: true,
    },
  },
  data() {
    return {
      underlineWidth: 0,
      sliceSize: 0,
      visibleSliceSize: 0,
      activeTabIndex: 0,
      selectedTab: capitalizeFirst(this.defaultTab),
    };
  },
  computed: {
    flatTabs() {
      return this.tabs.map((tab: any) => tab.text);
    },
  },
  watch: {
    $route(to) {
      this.$emit('tabChange', to.query.stage);
      this.onUpdateMobileMenu(to.query.stage);
    },
  },
  mounted() {
    this.initUnderlinePosition();
    this.setStickyNavObserver();
    this.resizeListener();
  },
  methods: {
    setUnderlinePosition(index: number) {
      const stickyNav = document.querySelector('.features-menu-wrapper') as any;
      const heroHeight = document.querySelector('.features-hero') as any;
      if (window && stickyNav.classList.contains('is-pinned')) {
        window.scrollTo({
          top: heroHeight.getBoundingClientRect().height,
          behavior: 'smooth',
        });
      }
      this.activeTabIndex = index;
      this.underlineWidth = this.sliceSize * index;
      this.selectedTab = (this.tabs as [any])[index].text;
    },
    initUnderlinePosition() {
      this.sliceSize = 100 / this.tabs.length;
      this.visibleSliceSize = 100 / this.tabs.length;
      this.setUnderlinePosition(
        this.tabs.findIndex(
          (item: any) =>
            item.text.toLowerCase() === this.selectedTab.toLowerCase(),
        ),
      );
    },
    onUpdateMobileMenu(tab: string) {
      this.setUnderlinePosition(
        this.tabs.findIndex(
          (item: any) => item.text.toLowerCase() === tab.toLowerCase(),
        ),
      );
      this.$router.push({ path: '', query: { stage: tab.toLowerCase() } });
    },
    setStickyNavObserver() {
      const mainNavDistanceFromTop = document
        .querySelector('.nav-hoc')
        ?.getBoundingClientRect().height as number;
      const observer = new IntersectionObserver(this.setStickyNav, {
        rootMargin: `-${mainNavDistanceFromTop}px 0px 0px 0px`,
        threshold: 0,
      });
      const children = Array.from(document.querySelectorAll('.features-hero'));
      children.forEach((child) => observer.observe(child));
    },

    resizeListener() {
      window.addEventListener(
        'resize',
        debounce(() => {
          this.setStickyNav(null);
        }, 100),
      );
    },

    setStickyNav(entries: any) {
      const stickyNav = document.querySelector('.features-menu-wrapper') as any;
      const mainNavDistanceFromTop = document
        .querySelector('.nav-hoc')
        ?.getBoundingClientRect().height as number;
      stickyNav.style.top = `${mainNavDistanceFromTop}px`;
      if (entries) {
        entries.forEach((entry: any) => {
          if (!entry.isIntersecting) {
            stickyNav.classList.add('is-pinned');
          } else {
            stickyNav.classList.remove('is-pinned');
          }
        });
      }
    },
  },
});
</script>

<template>
  <section
    data-aos="fade-right"
    data-aos-duration="800"
    class="features-menu-wrapper"
  >
    <div class="features-menu">
      <div class="features-menu__list">
        <ul>
          <li v-for="(tab, index) of tabs" :key="`${tab.text}-${index}`">
            <router-link
              :data-ga-features="tab.text.toLowerCase()"
              data-ga-location="features section"
              class="features-menu__item"
              exact-active-class="features-menu__item--active"
              :to="{ path: '', query: { stage: tab.text.toLowerCase() } }"
              @click.native="setUnderlinePosition(index)"
            >
              <SlpIcon
                v-if="tab.icon"
                class="features-menu__icon"
                :name="tab.icon.name"
                :alt="tab.icon.alt"
                size="md"
                :variant="tab.icon.variant"
              />
              <SlpTypography
                class="features-menu__text"
                tag="span"
                variant="body2"
                >{{ tab.text }}
              </SlpTypography>
            </router-link>
          </li>
        </ul>
        <hr
          class="features-menu__slider"
          :style="{
            width: `${visibleSliceSize}%`,
            'margin-left': `${underlineWidth}%`,
          }"
        />
      </div>
      <SlpDropdown
        v-model="selectedTab"
        class="features-menu__mobile-dropdown"
        :options="flatTabs"
        name="mobileMenu"
        :dropdown-label="dropdownLabel"
        @mobileMenu="onUpdateMobileMenu"
      />
    </div>
  </section>
</template>

<style scoped lang="scss">
$menu-border: 2px solid $color-surface-200;

.features-menu {
  display: flex;
  justify-content: center;
  margin-bottom: $spacing-16;
  position: relative;

  @media (min-width: $breakpoint-md) {
    margin-bottom: $spacing-96;
  }

  &__list {
    display: none;
    width: 100%;
    justify-content: center;
    flex-direction: column;
    border-bottom: $menu-border;

    @media (min-width: $breakpoint-md) {
      display: flex;
    }

    ul {
      display: flex;
      justify-content: space-between;
      li {
        flex: 1 1 100%;
      }
    }
  }

  &__mobile-dropdown {
    display: flex;
    width: 100%;
    margin-bottom: $spacing-32;

    @media (min-width: $breakpoint-md) {
      display: none;
    }

    &:after {
      top: 12px;
    }
  }

  &__item {
    display: flex;
    flex-direction: column;
    align-items: center;
    padding: $spacing-16 0;
    min-width: 70px;
    cursor: pointer;
    transition: all 0.3s ease-in;

    @media (min-width: $breakpoint-lg) {
      min-width: 100px;
    }

    @media (min-width: $breakpoint-xl) {
      min-width: 110px;
    }

    &--active {
      .features-menu__text {
        color: $color-text-link-100;
      }
    }

    &:hover {
      text-decoration: none;
      filter: brightness(70%);

      .features-menu__text {
        color: $color-text-link-100;
      }
    }
  }

  &__icon {
    width: 24px;
    margin-bottom: $spacing-4;
  }

  &__text {
    color: $color-text-300;
    font-weight: $font-weight-bold;
  }

  &__slider {
    height: 4px;
    margin: -2px;
    background: $color-text-link-100;
    border: none;
    transition: margin 0.5s cubic-bezier(0.93, 0.16, 0.64, 0.54);
  }

  &-wrapper {
    position: sticky;
    background: $color-primary-300;
    top: -1px;
    z-index: 1000;
    transform: scale(1);
    transition: transform 0.2s ease-in-out;
    transform-origin: top center;

    &:before {
      content: '';
      position: absolute;
      width: 200vw;
      left: 50%;
      transform: translateX(-50%);
      height: 100%;
      background: $color-primary-300;
      box-shadow: 0px 8px 50px -16px $color-primary-300;
      transition: box-shadow 0.2s ease-in;
    }
    &.is-pinned {
      transform: scale(0.9);
      &::before {
        box-shadow: 0px 8px 50px -16px $color-primary-100;
      }
    }
  }
}
</style>
